/* GCC */

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <climits>
#include <iterator>
#include <queue>
using namespace std;

#define ALL(cont)(cont).begin(), (cont).end()

const int Male = 1, Female = 2;

struct Person
{
    string name;
    vector<int> parents;
    vector<int> children;
    int wife;
    int level;
    int gender;
    Person(string n):name(n), wife(-1), level(INT_MAX), gender(-1) {}
};

vector<Person> pers;

int get_person(string name)
{
    for (int i=0;i<pers.size(); ++i) {
        if (pers[i].name == name)
            return i;
    }
    pers.push_back(Person(name));
    return pers.size()-1;
}

string low(string name)
{
    for (int i=0;i<name.size();++i) {
        char ch= 0;
        switch(name[i])
        {
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        case '':
            ch = '';
            break;
        }
        if (ch != 0)
            name[i]  = ch;
    }
    return name;
}

string rodov(string name)
{
    string ans = name;
    string temp = low(ans);
    char ch = temp.at(name.size()-1);
    char& ch2 = ans[name.size()-1];
    if (ch == '')
        ch2 = '';
    else if (ch == '')
        ch2 = '';
    else if (ch == '')
        ch2 = '';
    else if (low(name) == "") {
        ans.push_back('');
    } else if (ch == '')
        ch2 = '';
    else
        ans.push_back('');
    return ans;
}

string nazuv(string name)
{
    string ans = name;
    char ch = low(name)[name.size()-1];
    char& ch2 = ans[name.size()-1];

    if (ch == '')
        ch2 = '';
    else if (ch == '')
        ch2 = '';
    else if (low(name) == "") {
        ans.erase(ans.end()-1);
    } else if (ch == '')
        ch2 = '';
    else
        ans.erase(ans.end()-1);

    return ans;
}

void bfs(int st)
{
    queue<int> q;

    q.push(st);

    bool used[40] = {};

    pers[st].level = 0;

    while (!q.empty())
    {
        Person& p = pers[q.front()];
        int l = p.level;

        used[q.front()] = true;
        q.pop();

        if(p.wife != -1 && !used[p.wife]) {
            pers[p.wife].level = l;
            used[p.wife] = true;
            q.push(p.wife);
        }


        for (int i =0;i<p.parents.size();++i) {
            int prnt = p.parents[i];
            if (!used[prnt]) {
                pers[prnt].level = l-1;
                used[prnt] = true;
                q.push(prnt);
            }
        }

        for (int i=0;i<p.children.size();++i) {
            int child = p.children[i];
            if (!used[child]) {
                pers[child].level = l+1;
                used[child] = true;
                q.push(child);
            }
        }

    }
}

bool is_sister(int from, int to)
{
    if (pers[from].level == pers[to].level && pers[from].gender == Female && pers[to].gender == Male) {
        sort(ALL(pers[from].parents));
        sort(ALL(pers[to].parents));

        return pers[from].parents == pers[to].parents&& !pers[from].parents.empty();
    }
    return false;
}

bool is_brother(int from, int to)
{
    if (pers[from].level == pers[to].level && pers[from].gender == Male && pers[to].gender == Female) {
        sort(ALL(pers[from].parents));
        sort(ALL(pers[to].parents));

        return pers[from].parents == pers[to].parents && !pers[from].parents.empty();
    }
    return false;
}

bool is_sis_or_br(int from, int to)
{
    return is_sister(from, to) || is_brother(from, to);
}

bool is_mother(int who, int to)
{
    if (pers[who].gender == Female && find(ALL(pers[who].children), to) != pers[who].children.end())
        return true;
    return false;
}

bool is_parent(int who, int to)
{
    if (find(ALL(pers[who].children), to) != pers[who].children.end())
        return true;
    return false;
}

bool is_dad(int who, int to)
{
    if (pers[who].gender == Male && find(ALL(pers[who].children), to) != pers[who].children.end())
        return true;
    return false;
}

bool is_son(int who, int to)
{
    if (pers[who].gender == Male && find(ALL(pers[who].parents), to) != pers[who].parents.end())
        return true;
    return false;
}

bool is_daughter(int who, int to)
{
    if (pers[who].gender == Female && find(ALL(pers[who].parents), to) != pers[who].parents.end())
        return true;
    return false;
}

bool is_husband(int who, int to)
{
    if (pers[who].wife == to && pers[who].gender == Male)
        return true;
    return false;
}

bool is_wife(int who, int to)
{
    if (pers[who].wife == to && pers[who].gender == Female)
        return true;
    return false;
}

int get_wife(int who)
{
    if (pers[who].gender == Male)
        return pers[who].wife;
    return -1;
}

int get_husband(int who)
{
    if (pers[who].gender == Female)
        return pers[who].wife;
    return -1;
}

int get_father(int who)
{

    if (pers[who].parents.size() >= 1 && pers[pers[who].parents[0]].gender == Male)
        return pers[who].parents[0];
    else if (pers[who].parents.size() >= 2 && pers[pers[who].parents[0]].gender == Male)
        return pers[who].parents[1];
    else
        return -1;
}

int get_mother(int who)
{

    if (pers[who].parents.size() >= 1 && pers[pers[who].parents[0]].gender == Female)
        return pers[who].parents[0];
    else if (pers[who].parents.size() >= 2 && pers[pers[who].parents[0]].gender == Female)
        return pers[who].parents[1];
    else
        return -1;
}

string who_is_who(int who, int to)
{
    if (is_dad(who, to))
        return "";
    if (is_mother(who, to))
        return "";
    if (is_son(who, to))
        return "";
    if (is_daughter(who, to))
        return "";
    if (is_sister(who, to))
        return "";
    if (is_brother(who, to))
        return "";
    if (is_husband(who, to))
        return "";
    if (is_wife(who, to))
        return "";

    for (int i = 0; i < pers.size(); ++i) {
        if (i != who && i != to) {
            if (is_parent(i, who) && is_parent(to, i)) {
                if (pers[who].gender == Male)
                    return "";
                else
                    return "";
            }
            if (is_parent(i, to) && is_parent(who, i)) {
                if (pers[who].gender == Male)
                    return "";
                else
                    return "";
            }
            if (is_dad(i, to) && is_brother(who, i))
                return "";
            if (is_dad(i, to) && is_sister(who, i))
                return "";
            if (is_mother(i, to) && is_brother(who, i))
                return "";
            if (is_mother(i, to) && is_sister(who, i))
                return "";
            if (is_son(who, i) && is_sis_or_br(i, to))
                return "";
            if (is_daughter(who, i) && is_sis_or_br(i, to))
                return "";
            if (is_dad(who, i) && is_husband(i, to))
                return "";
            if (is_mother(who, i) && is_husband(i, to))
                return "";
            if (is_dad(who, i) && is_wife(i, to))
                return "";
            if (is_mother(who, i) && is_wife(i, to))
                return "";
            if (is_husband(who, i) && is_daughter(i, to))
                return "";
            if (is_wife(who, i) && is_son(i, to))
                return "";
            if (is_sister(who, i) && is_husband(i, to))
                return "";
            if (is_brother(who, i) && is_husband(i, to))
                return "";
            if (is_husband(who, i) && is_sister(i, to))
                return "";
            if (is_wife(who, i) && is_brother(i, to))
                return "";

        }
    }

    return " ";
}

int main()
{
    freopen("family.in", "r", stdin);
    freopen("family.out", "w", stdout);
    string from, to;
    cin >> from >> to;

    while (1) {
        string t, p1, p2, how;
        cin >> p1 >> t >> how >> p2;
        if (!cin)
            break;
        int iwho = get_person(p1),
            iwhom = get_person(nazuv(p2));
        Person& who = pers[iwho];
        Person& whom = pers[iwhom];

        if (how == "") {
            who.gender = Female;
            who.wife = iwhom;
            whom.gender = Male;
            whom.wife = iwho;
            vector<int> child;

            sort(ALL(who.children));
            sort(ALL(whom.children));

            merge(ALL(who.children), ALL(whom.children), back_inserter(child));

            for (int i =0;i<child.size(); ++i) {
                Person &ch = pers[child[i]];
                if (ch.parents.size() == 1) {
                    if (ch.parents[0] == iwho)
                        ch.parents.push_back(iwhom);
                    else
                         ch.parents.push_back(iwho);
                } else if (ch.parents.size() == 0) {
                        ch.parents.push_back(iwho);
                        ch.parents.push_back(iwhom);
                    }
            }

            who.children = whom.children = child;
        }
        else if (how == "") {
            who.gender = Male;
            who.parents.push_back(iwhom);
            whom.children.push_back(iwho);
            if (whom.wife != -1) {
                pers[whom.wife].children.push_back(iwho);
                who.parents.push_back(whom.wife);
            }
        }
        else if (how == "") {
            who.gender = Female;
            who.parents.push_back(iwhom);
            whom.children.push_back(iwho);
            if (whom.wife != -1) {
                pers[whom.wife].children.push_back(iwho);
                who.parents.push_back(whom.wife);
            }
        }
    }

    int st = get_person(from);
    bfs(st);

    int en = get_person(to);

    cout << from << " - " << who_is_who(st, en) << " " << rodov(to) << endl;


    return 0;
}
