/* GCC */
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct pinfo
{
	pinfo(int _v, bool _male = false)
		: v(_v), male(_male)
	{}
	int v;
	bool male;
};

string first, second, who, p1, p2, r;
map<string, pinfo> table;
map<string, string> match;
char ch;
bool male[31], used[31] = {};
int curV(0), husband[31], fv, sv, ans(1000);
vector<int> parent[31], childs[31], path;

inline void add_parent(int s, int p)
{
	if (parent[s].size() == 0)
	{
		parent[s].push_back(p);
		return;
	}
	if (parent[s].size() == 2 || parent[s][0] == p)
		return;
	parent[s].push_back(p);
}

inline void add_child(int s, int p)
{
	for (int i = 0; i < childs[p].size(); ++i)
		if (childs[p][i] == s)
			return;
	childs[p].push_back(s);
}

inline char& last(string& str)
{
	return str[str.size() - 1];
}

void normalize(string& p, map<string, pinfo>::iterator& it)
{
	char& ending = last(p);
	int m = 0;
	if (p.size() == 5 &&
		(p[0] == '' || p[0] == '') &&
		(p[1] == '' || p[1] == '') &&
		(p[2] == '' || p[2] == '') &&
		(p[3] == '' || p[3] == '') &&
		(p[4] == '' || p[4] == ''))
		p.erase(p.size() - 1, 1), m = 1;
	else if (ending == '' || ending == '')
		ending = (ending == '' ? '' : ''), m = 1;
	else if (ending == '' || ending == '')
		p.erase(p.size() - 1, 1), m = 1;
	else if (ending == '' || ending == '')
		ending = (ending == '' ? '' : '');
	else if (ending == '' || ending == '')
		ending = (ending == '' ? '' : ''), m = 2;
	it = table.find(p);
	if (it == table.end())
		it = table.insert(make_pair(p, pinfo(curV++))).first;
	if (m != 0)
		it->second.male = (m == 1);
}

void denorm(string& p)
{
	char& ending = last(p);
	if (p.size() == 4 &&
		(p[0] == '' || p[0] == '') &&
		(p[1] == '' || p[1] == '') &&
		(p[2] == '' || p[2] == '') &&
		(p[3] == '' || p[3] == ''))
		p.push_back('');
	else if (ending == '' || ending == '')
		ending = '';
	else if (ending == '' || ending == '')
		ending = '';
	else if (ending == '' || ending == '')
		ending = '';
	else if (ending == '' || ending == '')
		ending = '';
	else
		p.push_back('');
}

void rel(void)
{
	if (r.size() >= ans)
		return;
	ans = r.size();
	if (male[path[0]])
		r.push_back('m');
	else
		r.push_back('f');
	who = match[r];
	r.erase(r.size() - 1, 1);
}

void dfs(int v, int pr)
{
	path.push_back(v);
	used[v] = true;
	if (v == sv)
		rel();
	if (husband[v] != -1 && husband[v] != pr && !used[husband[v]])
	{
		r.push_back('0');
		dfs(husband[v], v);
		r.erase(r.size() - 1, 1);
	}
	for (int i = 0; i < childs[v].size(); ++i)
	{
		const int to = childs[v][i];
		if (to != pr && !used[husband[v]])
		{
			r.push_back('d');
			dfs(to, v);
			r.erase(r.size() - 1, 1);
		}
	}
	for (int i = 0; i < parent[v].size(); ++i)
	{
		const int to = parent[v][i];
		if (to != pr && !used[husband[v]])
		{
			r.push_back('u');
			dfs(to, v);
			r.erase(r.size() - 1, 1);
		}
	}
	used[v] = false;
	path.pop_back();
}

int main(void)
{
	ios_base::sync_with_stdio(false);
	for (int i = 0; i < 31; ++i)
		husband[i] = -1;
	match["dm"] = "";
	match["df"] = "";
	match["um"] = "";
	match["uf"] = "";
	match["0m"] = "";
	match["0f"] = "";
	match["ddm"] = "";
	match["ddf"] = "";
	match["dddm"] = "";
	match["dddf"] = "";
	match["uum"] = "";
	match["uuf"] = "";
	match["uuum"] = "";
	match["uuuf"] = "";
	match["dum"] = "";
	match["udm"] = "";
	match["duf"] = "";
	match["udf"] = "";
	ifstream in("family.in");
	in >> first >> second;
	map<string, pinfo>::iterator it1, it2;
	while (true)
	{
		in >> p1 >> ch >> who >> p2;
		if (in.eof())
			break;
		it1 = table.find(p1);
		if (it1 == table.end())
			it1 = table.insert(make_pair(p1, pinfo(curV++))).first;
		normalize(p2, it2);
		if (who[1] == '')
		{
			it1->second.male = true;
			add_parent(it1->second.v, it2->second.v);
			childs[it2->second.v].push_back(it1->second.v);
		}
		else
		{
			it1->second.male = false;
			if (who[1] == '')
			{
				add_parent(it1->second.v, it2->second.v);
				childs[it2->second.v].push_back(it1->second.v);
			}
			else
            {
                it2->second.male = true;
				husband[it1->second.v] = it2->second.v, husband[it2->second.v] = it1->second.v;
            }
		}
	}
	in.close();
	for (it1 = table.begin(); it1 != table.end(); ++it1)
		male[it1->second.v] = it1->second.male;
	for (int i = 0; i < curV; ++i)
	{
		set<int> pars;
		pars.insert(i);
		if (husband[i] != -1)
			pars.insert(husband[i]);
		else
			for (int j = 0; j < childs[i].size(); ++j)
			{
				const int chld = childs[i][j];
				for (int par = 0; par < parent[chld].size(); ++par)
					pars.insert(parent[chld][par]);
			}
		for (int j = 0; j < childs[i].size(); ++j)
		{
			const int chld = childs[i][j];
			for (set<int>::iterator pit = pars.begin(); pit != pars.end(); ++pit)
			{
				add_parent(chld, *pit);
				add_child(chld, *pit);
			}
		}
		if (pars.size() == 2)
		{
			const int wife = *pars.begin(), husb = *(++pars.begin());
			husband[wife] = husb, husband[husb] = wife;
		}
	}
	it1 = table.find(first), it2 = table.find(second);
	fv = it1->second.v, sv = it2->second.v;
	dfs(fv, -1);
	ofstream out("family.out");
	denorm(second);
	if(last(first) == '')
        last(first) = '';
    if(last(first) == '')
        last(first) = '';
    if(last(first) == '')
        last(first) = '';
    if(last(first) == '')
        last(first) = '';
	out << first << " - " << who << ' ' << second << '\n';
	out.close();
	return 0;
}
